//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%399428BC0078.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%399428BC0078.cm

//## begin module%399428BC0078.cp preserve=no
//## end module%399428BC0078.cp

//## Module: XspecRegistry%399428BC0078; Package specification
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/DataFactory/XspecRegistry.h

#ifndef XSPECREGISTRY_H
#define XSPECREGISTRY_H 1

//## begin module%399428BC0078.additionalIncludes preserve=no
//## end module%399428BC0078.additionalIncludes

//## begin module%399428BC0078.includes preserve=yes
//## end module%399428BC0078.includes

// map
#include <map>
// Error
#include <XSUtil/Error/Error.h>
// XspecDataIO
#include <XSModel/DataFactory/XspecDataIO.h>

class DataFactory;
class DataPrototype;

//## begin module%399428BC0078.declarations preserve=no
//## end module%399428BC0078.declarations

//## begin module%399428BC0078.additionalDeclarations preserve=yes
#include <typeinfo>
//## end module%399428BC0078.additionalDeclarations


//## begin XspecRegistry%399427D601CA.preface preserve=yes
//## end XspecRegistry%399427D601CA.preface

//## Class: XspecRegistry%399427D601CA
//## Category: XSModel::DataFactory%399415D40147
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%39D9FE45011B;friend DataPrototype { -> }
//## Uses: <unnamed>%39DA15F8016A;RedAlert { -> }
//## Uses: <unnamed>%39DA15FB00AF;YellowAlert { -> }
//## Uses: <unnamed>%39DA23FF0308;DataFactory { -> F}

class XspecRegistry 
{
  //## begin XspecRegistry%399427D601CA.initialDeclarations preserve=yes
  //## end XspecRegistry%399427D601CA.initialDeclarations

  public:
    //## Class: UnrecognizedFormat%39FF33B101AD
    //## Category: XSModel::DataFactory%399415D40147
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class UnrecognizedFormat : public YellowAlert  //## Inherits: <unnamed>%39FF3430021F
    {
      public:
        //## Constructors (specified)
          //## Operation: UnrecognizedFormat%39FF34670389
          UnrecognizedFormat (const string& msg);

      protected:
      private:
      private: //## implementation
    };

    //## Destructor (generated)
      virtual ~XspecRegistry();


    //## Other Operations (specified)
      //## Operation: addToRegistry%399959F90242
      virtual void addToRegistry (DataFactory* factory);

      //## Operation: Instance%39DA2461003B
      static XspecRegistry* Instance ();

      //## Operation: returnPrototype%39ECB51000AF
      DataPrototype* returnPrototype (const string& fileName, XspecDataIO::DataType type = XspecDataIO::SpectrumType);

      //## Operation: returnPrototype%3E96F01B039F
      DataPrototype* returnPrototype (const std::type_info& dataClass);

  public:
    // Additional Public Declarations
      //## begin XspecRegistry%399427D601CA.public preserve=yes
      //## end XspecRegistry%399427D601CA.public

  protected:
    //## Constructors (generated)
      XspecRegistry();

    // Additional Protected Declarations
      //## begin XspecRegistry%399427D601CA.protected preserve=yes
      //## end XspecRegistry%399427D601CA.protected

  private:

    //## Other Operations (specified)
      //## Operation: registerNativeTypes%39D9F2910153
      void registerNativeTypes ();

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::DataFactory::<unnamed>%399DB15A01E7
      //## Role: XspecRegistry::dataFormats%399DB15B0148
      //## Qualifier: type%39D9EDF30398; const char*
      const std::map<const char*, DataPrototype*> dataFormats () const;
      void dataFormats (std::map<const char*, DataPrototype*> value);
      const DataPrototype* dataFormats (const char* type) const;
      void dataFormats (const char* type, DataPrototype* value);

    // Additional Private Declarations
      //## begin XspecRegistry%399427D601CA.private preserve=yes
      //## end XspecRegistry%399427D601CA.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: instance%39DA245C0015
      //## begin XspecRegistry::instance%39DA245C0015.attr preserve=no  private: static XspecRegistry* {U} 0
      static XspecRegistry* s_instance;
      //## end XspecRegistry::instance%39DA245C0015.attr

    // Data Members for Associations

      //## Association: XSModel::DataFactory::<unnamed>%399DB15A01E7
      //## begin XspecRegistry::dataFormats%399DB15B0148.role preserve=no  private: DataPrototype {1 -> 1RFHgN}
      std::map<const char*, DataPrototype*> m_dataFormats;
      //## end XspecRegistry::dataFormats%399DB15B0148.role

    // Additional Implementation Declarations
      //## begin XspecRegistry%399427D601CA.implementation preserve=yes
      //## end XspecRegistry%399427D601CA.implementation

};

//## begin XspecRegistry%399427D601CA.postscript preserve=yes
//## end XspecRegistry%399427D601CA.postscript

//## begin RegisteredFormat%3999454501BC.preface preserve=yes
//## end RegisteredFormat%3999454501BC.preface

//## Class: RegisteredFormat%3999454501BC
//	Abstract interface representing the behavior of classes
//	that represent datasets. The datasets are read in from
//	files.
//
//	The formatFound() instruction returns true if the file
//	is of the format appropriate to the class.
//
//	The register() operation adds a pointer to an empty
//	class instance to a container type in a registry.
//
//	The datasets to be represented are required to register
//	themselves at some initialization stage. The  companion
//	type Registry class holds containers of pointers to
//	dummy dataset pointers.
//
//	Thus, when a new file is read, the registry can be
//	traversed and the format() operation called for each
//	class in the registry in turn to identify which subclass
//	of the base datatype to instantiate.
//## Category: XSModel::DataFactory%399415D40147
//## Subsystem: XSModel::DataFactory%3994285E0087
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class RegisteredFormat 
{
  //## begin RegisteredFormat%3999454501BC.initialDeclarations preserve=yes
  //## end RegisteredFormat%3999454501BC.initialDeclarations

  public:
    //## Constructors (generated)
      RegisteredFormat();

    //## Destructor (generated)
      virtual ~RegisteredFormat() = 0;


    //## Other Operations (specified)
      //## Operation: fileFormat%399945640000
      //	type() returns true if the input filename is of the
      //	format corresponding to the class.
      virtual bool fileFormat (const string& fileName, XspecDataIO::DataType type = XspecDataIO::SpectrumType) = 0;

      //## Operation: isRegistered%399967C6008E
      bool isRegistered (const XspecRegistry& registry) const;

    // Additional Public Declarations
      //## begin RegisteredFormat%3999454501BC.public preserve=yes
      //## end RegisteredFormat%3999454501BC.public

  protected:
    // Additional Protected Declarations
      //## begin RegisteredFormat%3999454501BC.protected preserve=yes
      //## end RegisteredFormat%3999454501BC.protected

  private:
    //## Constructors (generated)
      RegisteredFormat(const RegisteredFormat &right);

    //## Assignment Operation (generated)
      RegisteredFormat & operator=(const RegisteredFormat &right);

    // Additional Private Declarations
      //## begin RegisteredFormat%3999454501BC.private preserve=yes
      //## end RegisteredFormat%3999454501BC.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin RegisteredFormat%3999454501BC.implementation preserve=yes
      //## end RegisteredFormat%3999454501BC.implementation

};

//## begin RegisteredFormat%3999454501BC.postscript preserve=yes
//## end RegisteredFormat%3999454501BC.postscript

// Class XspecRegistry::UnrecognizedFormat 

// Class XspecRegistry 

//## Get and Set Operations for Associations (inline)

inline const std::map<const char*, DataPrototype*> XspecRegistry::dataFormats () const
{
  //## begin XspecRegistry::dataFormats%399DB15B0148.get preserve=no
  return m_dataFormats;
  //## end XspecRegistry::dataFormats%399DB15B0148.get
}

inline void XspecRegistry::dataFormats (std::map<const char*, DataPrototype*> value)
{
  //## begin XspecRegistry::dataFormats%399DB15B0148.set preserve=no
  m_dataFormats = value;
  //## end XspecRegistry::dataFormats%399DB15B0148.set
}

inline const DataPrototype* XspecRegistry::dataFormats (const char* type) const
{
  //## begin XspecRegistry::dataFormats%399DB15B0148.qualget preserve=no
  return m_dataFormats.find(type)->second;
  //## end XspecRegistry::dataFormats%399DB15B0148.qualget
}

inline void XspecRegistry::dataFormats (const char* type, DataPrototype* value)
{
  //## begin XspecRegistry::dataFormats%399DB15B0148.qualset preserve=no
  m_dataFormats[type] = value;
  //## end XspecRegistry::dataFormats%399DB15B0148.qualset
}

// Class RegisteredFormat 

//## begin module%399428BC0078.epilog preserve=yes
//## end module%399428BC0078.epilog


#endif
